/** I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include "system\typedefs.h"

#include "system\usb\usb.h"

#include "io_cfg.h"             // I/O pin mapping
#include "user.h"
#include "delays.h"

/** V A R I A B L E S ********************************************************/
#pragma udata
char Buffer[64];

/** D E C L A R A T I O N S **************************************************/
#pragma code
void UserInit(void)
{
// on met configure tout en entre

	TRISA = 0b11111111;
	TRISB = 0b11110000;
	TRISC = 0b00000000;   // rc1 et rc2 a zero en sortie
	TRISD = 0b00000000;
	TRISE = 0b11111011;

	CCPR1 = 255; // parametrage de la periode on met le maximum pour avoir toute la resolution
	CCPR2 = 255;

	T2CON = 0b00000100; // regle timer 2 prescale 1 et enable

    //CONFIG3H.CCP2MX=1; 	//	CCP2MX = 1;			// selection CCP2 sur RC2 pins 17 p286
	//CCP1CON = 0b00001100;	// configuration du mode PWM 1
	//CCP2CON = 0b00001100;   // configuration du mode PWM 2
	ADCON0bits.ADON = 0;
	ADCON1 = 0b000001111; // on fixe les ref et on desactive les voies ana 
	
}//end UserInit
// *****************************************************************************/
void ProcessIO(void)
{   
	int i;
	static pressed=0;
	static demande=0;

   if (HIDRxReport(Buffer,PacketSize ) > 0) // USB receive buffer has data
    
	{		// cas de la lecture des Inputs TOR
		if (Buffer[0]==0)
		{	
			demande=1;
			Buffer[1]=PORTAbits.RA0;
			Buffer[2]=PORTAbits.RA1;
			Buffer[3]=PORTAbits.RA2;
			Buffer[4]=PORTAbits.RA3;
			Buffer[5]=PORTAbits.RA4;
			Buffer[6]=PORTEbits.RE1;
			Buffer[7]=PORTAbits.RA5;
			Buffer[8]=PORTEbits.RE0;
        	while (demande==1)
			{
			if(!mHIDTxIsBusy()) {                 // blocking
        	HIDTxReport(Buffer, PacketSize );   // transmit packet
			demande=0;}
			}
		}
		// cas de l'ecriture des sorties TOR
		if (Buffer[0]==1)
		{
			PORTBbits.RB2=Buffer[1];
			PORTBbits.RB0=Buffer[2];
			PORTBbits.RB1=Buffer[3];
			PORTDbits.RD7=Buffer[4];
			PORTBbits.RB3=Buffer[5];
			PORTDbits.RD6=Buffer[6];
			PORTDbits.RD4=Buffer[7];
			PORTDbits.RD3=Buffer[8];
			PORTDbits.RD1=Buffer[9];
			PORTDbits.RD2=Buffer[10];
			PORTDbits.RD0=Buffer[11];
			PORTCbits.RC2=Buffer[12];
			PORTCbits.RC1=Buffer[13];
			PORTCbits.RC0=Buffer[14];
			PORTEbits.RE2=Buffer[15];
		}	
	}	
}//end ProcessIO
